## elf-dissector 0.0+p24.04+vunstable+git20251028.0923

=== debian/changelog ===
elf-dissector (0.0+p24.04+vunstable+git20251028.0923-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Tue, 28 Oct 2025 09:23:33 +0000

elf-dissector (0.0-0neon) bionic; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Wed, 20 Mar 2019 12:10:07 +0000

## elf-dissector 0.0+p24.04+vunstable+git20251111.0355

=== debian/changelog ===
elf-dissector (0.0+p24.04+vunstable+git20251111.0355-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Tue, 11 Nov 2025 03:55:05 +0000

## elf-dissector 0.0+p24.04+vunstable+git20260105.1310

=== CMakeLists.txt ===
# CMake setup
cmake_minimum_required(VERSION 3.16)
project(elf-dissector VERSION 0.0.1)

find_package(ECM 6.0 REQUIRED NO_MODULE)
set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH} ${CMAKE_SOURCE_DIR}/cmake)

include(KDECompilerSettings NO_POLICY_SCOPE)
include(ECMSetupVersion)
include(ECMPoQmTools)
include(ECMInstallIcons)
include(ECMDeprecationSettings)
include(FeatureSummary)
include(KDEInstallDirs)
include(KDECMakeSettings)
include(DetectLinker)

set(CMAKE_AUTOUIC on)
set(CMAKE_AUTORCC on)
set(CMAKE_CXX_VISIBILITY_PRESET "hidden")
set(CMAKE_VISIBILITY_INLINES_HIDDEN on)
set(CMAKE_C_STANDARD 11)
set(CMAKE_CXX_STANDARD 14)
enable_testing()

# version setup
set(PROJECT_VERSION_STRING "${PROJECT_VERSION}")
if(EXISTS "${CMAKE_SOURCE_DIR}/.git")
  find_package(Git)
  set_package_properties(Git PROPERTIES TYPE OPTIONAL PURPOSE "Determine exact build version.")
  if(GIT_FOUND)
    execute_process(
      COMMAND ${GIT_EXECUTABLE} rev-parse --short HEAD
      WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
      OUTPUT_VARIABLE _git_revision
    )
    string(REGEX REPLACE "\n" "" _git_revision "${_git_revision}")
    set(PROJECT_VERSION_STRING "${PROJECT_VERSION_STRING} (revision: ${_git_revision})")
  endif()
endif()

# compiler setup
if(CMAKE_SYSTEM_NAME MATCHES Linux OR CMAKE_SYSTEM_NAME STREQUAL GNU)
  if(CMAKE_COMPILER_IS_GNUCXX OR "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
    set(EXTRA_LINKER_FLAGS "-Wl,--hash-style=both")
    set(CMAKE_EXE_LINKER_FLAGS "${EXTRA_LINKER_FLAGS} ${CMAKE_EXE_LINKER_FLAGS}")
    set(CMAKE_SHARED_LINKER_FLAGS "${EXTRA_LINKER_FLAGS} ${CMAKE_SHARED_LINKER_FLAGS}")
    set(CMAKE_MODULE_LINKER_FLAGS "${EXTRA_LINKER_FLAGS} ${CMAKE_MODULE_LINKER_FLAGS}")
  endif()
endif()

# dependencies
find_package(Qt6 6.7 COMPONENTS Widgets Test NO_MODULE REQUIRED)

find_package(Iberty REQUIRED)
find_package(Dwarf 0.10)
if (TARGET Dwarf::Dwarf)
    set(HAVE_DWARF TRUE)
endif()
if (NOT OPCODES_FOUND)
    message(FATAL_ERROR "Binutils::Opcodes library not found")
endif()
find_package(Capstone)
if (Capstone_FOUND)
    set(HAVE_CAPSTONE TRUE)
endif()
find_package(Gnuplot QUIET)
set_package_properties(Gnuplot PROPERTIES
    DESCRIPTION "a command-line driven graphing utility"
    URL "https://www.gnuplot.info/"
    PURPOSE "Required for the Performance benchmark tool"
    TYPE RUNTIME
)

# config files
configure_file(${CMAKE_SOURCE_DIR}/config-elf-dissector.h.cmake ${CMAKE_BINARY_DIR}/config-elf-dissector.h)
configure_file(${CMAKE_SOURCE_DIR}/config-elf-dissector-version.h.cmake ${CMAKE_BINARY_DIR}/config-elf-dissector-version.h)

ecm_install_po_files_as_qm(poqm)

ecm_set_disabled_deprecation_versions(
    QT 6.8.0
)

# build things
include_directories(
    ${CMAKE_SOURCE_DIR}/src
    ${CMAKE_SOURCE_DIR}/src/3rdparty
    ${CMAKE_SOURCE_DIR}/src/lib
    ${CMAKE_BINARY_DIR}
)

add_subdirectory(src)
if (BUILD_TESTING)
    add_subdirectory(tests)
endif()

feature_summary(WHAT ALL INCLUDE_QUIET_PACKAGES FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== src/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2019 Volker Krause <vkrause@kde.org>
# SPDX-License-Identifier: BSD-2-Clause

add_subdirectory(lib)
if (NOT ELF_DISSECTOR_NO_CLI_TOOLS)
    add_subdirectory(cli)
endif()
add_subdirectory(ui)

=== tests/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2013 Volker Krause <vkrause@kde.org>
# SPDX-License-Identifier: BSD-2-Clause

add_subdirectory(auto)
add_subdirectory(targets)
add_subdirectory(tools)

=== src/cli/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2019 Volker Krause <vkrause@kde.org>
# SPDX-License-Identifier: BSD-2-Clause

if (HAVE_DWARF)
    add_executable(elf-packcheck packcheck.cpp)
    target_link_libraries(elf-packcheck libelfdissector)
    install(TARGETS elf-packcheck ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})
endif()

add_executable(elf-depcheck depcheck.cpp)
target_link_libraries(elf-depcheck libelfdissector)
install(TARGETS elf-depcheck ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})

if (HAVE_DWARF)
    add_executable(elf-rtticheck rtticheck.cpp)
    target_link_libraries(elf-rtticheck libelfdissector)
    install(TARGETS elf-rtticheck ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})
endif()

add_executable(elf-optimizer optimizer.cpp)
target_link_libraries(elf-optimizer libelfdissector)
install(TARGETS elf-optimizer ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})

add_executable(elf-deadcodefinder deadcode.cpp)
target_link_libraries(elf-deadcodefinder libelfdissector)
install(TARGETS elf-deadcodefinder ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})

=== src/lib/CMakeLists.txt ===
set(libelfdisector_srcs
    elf/elfdynamicentry.cpp
    elf/elfdynamicsection.cpp
    elf/elffile.cpp
    elf/elffileset.cpp
    elf/elfgnudebuglinksection.cpp
    elf/elfgnuhashsection.cpp
    elf/elfgnusymbolversiontable.cpp
    elf/elfgnusymbolversiondefinition.cpp
    elf/elfgnusymbolversiondefinitionauxiliaryentry.cpp
    elf/elfgnusymbolversiondefinitionssection.cpp
    elf/elfgnusymbolversionrequirement.cpp
    elf/elfgnusymbolversionrequirementauxiliaryentry.cpp
    elf/elfgnusymbolversionrequirementssection.cpp
    elf/elfgotentry.cpp
    elf/elfgotsection.cpp
    elf/elfhashsection.cpp
    elf/elfheader.cpp
    elf/elfnoteentry.cpp
    elf/elfnotesection.cpp
    elf/elfpltentry.cpp
    elf/elfpltsection.cpp
    elf/elfrelocationentry.cpp
    elf/elfrelocationsection.cpp
    elf/elfreverserelocator.cpp
    elf/elfsectionheader.cpp
    elf/elfsection.cpp
    elf/elfsegmentheader.cpp
    elf/elfstringtablesection.cpp
    elf/elfsymboltableentry.cpp
    elf/elfsymboltablesection.cpp
    elf/elfsysvhashsection.cpp

    demangle/demangler.cpp

    disassmbler/disassembler.cpp

    checks/ldbenchmark.cpp
    checks/structurepackingcheck.cpp
    checks/dependenciescheck.cpp
    checks/virtualdtorcheck.cpp
    checks/deadcodefinder.cpp

    printers/dwarfprinter.cpp
    printers/dynamicsectionprinter.cpp
    printers/elfprinter.cpp
    printers/gnuversionprinter.cpp
    printers/notesectionprinter.cpp
    printers/relocationprinter.cpp
    printers/symbolprinter.cpp

    optimizers/dependencysorter.cpp
)
if (HAVE_DWARF)
    list(APPEND libelfdisector_srcs
        dwarf/dwarfaddressranges.cpp
        dwarf/dwarfcudie.cpp
        dwarf/dwarfinfo.cpp
        dwarf/dwarfdie.cpp
        dwarf/dwarfexpression.cpp
        dwarf/dwarfleb128.cpp
        dwarf/dwarfline.cpp
        dwarf/dwarfranges.cpp
    )
endif()

kde_source_files_enable_exceptions(elf/elffile.cpp)
add_library(libelfdissector STATIC ${libelfdisector_srcs})
target_link_libraries(libelfdissector PUBLIC Qt6::Core PRIVATE Binutils::Iberty Binutils::Opcodes)
if (HAVE_DWARF)
    target_link_libraries(libelfdissector PRIVATE Dwarf::Dwarf)
endif()
if (Capstone_FOUND)
    target_link_libraries(libelfdissector PRIVATE PkgConfig::Capstone)
endif()
# Rounabout FreeBSD specialty: binutils internals need libintl,
# which isn't linked by default because we use the binutils static libs.
if(CMAKE_SYSTEM_NAME MATCHES "FreeBSD")
    find_package(Intl REQUIRED)
    if(Intl_FOUND)
        if(TARGET Intl::Intl)
            target_link_libraries(libelfdissector PRIVATE Intl::Intl)
        else()
            target_link_libraries(libelfdissector PRIVATE ${Intl_LIBRARIES})
        endif()
    endif()
endif()

add_subdirectory(checks)

=== src/ui/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2019 Volker Krause <vkrause@kde.org>
# SPDX-License-Identifier: BSD-2-Clause

# all code in a static library, for usage in unit tests
set(libelfdissectorui_srcs
    ${CMAKE_SOURCE_DIR}/src/3rdparty/treemap/treemap.cpp

    elfmodel/elfmodel.cpp
    elfmodel/datavisitor.cpp
    elfmodel/indexvisitor.cpp
    elfmodel/parentvisitor.cpp
    elfmodel/rowcountvisitor.cpp
    elfmodel/sectionproxymodel.cpp

    dependencymodel/dependencymodel.cpp
    dependencymodel/usedsymbolmodel.cpp
    dependencymodel/unuseddependenciesmodel.cpp
    dependencymodel/filelistmodel.cpp
    dependencymodel/fileusermodel.cpp

    issuesmodel/issuesmodel.cpp

    loadbenchmarkmodel/loadbenchmarkmodel.cpp

    typemodel/typemodel.cpp

    navigator/codenavigator.cpp
    navigator/codenavigatorprinter.cpp

    plotter/gnuplotter.cpp
    plotter/plotter.qrc

    widgets/gnuplotwidget.cpp
    widgets/sidepane.cpp

    views/dependencyview.cpp
    views/elfstructureview.cpp
    views/issuesview.cpp
    views/loadbenchmarkview.cpp
    views/sizetreemapview.cpp
    views/typeview.cpp

    mainwindow.cpp
    colorizer.cpp
)

add_library(libelfdissectorui STATIC ${libelfdissectorui_srcs})
target_link_libraries(libelfdissectorui Qt6::Widgets libelfdissector)
if (HAVE_DWARF)
  target_link_libraries(libelfdissectorui Dwarf::Dwarf)
endif()

ecm_create_qm_loader(elfdissector_qm_loader elf-dissector_qt)
add_executable(elf-dissector
    ${elfdissector_qm_loader}
    main.cpp
)
target_link_libraries(elf-dissector libelfdissectorui)
install(TARGETS elf-dissector ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})

install(PROGRAMS org.kde.elf-dissector.desktop DESTINATION ${KDE_INSTALL_APPDIR})
install(FILES org.kde.elf-dissector.appdata.xml DESTINATION ${KDE_INSTALL_METAINFODIR})

ecm_install_icons(
  ICONS 16-apps-elf-dissector.svg  32-apps-elf-dissector.svg
  DESTINATION ${KDE_INSTALL_ICONDIR}
)

=== tests/auto/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2015 Volker Krause <vkrause@kde.org>
# SPDX-License-Identifier: BSD-2-Clause

add_executable(demangler_test demangler_test.cpp)
target_link_libraries(demangler_test Qt6::Test libelfdissector)
add_test(NAME test-demangle COMMAND demangler_test)

add_definitions(-DBINDIR="${CMAKE_BINARY_DIR}/${KDE_INSTALL_BINDIR}/")

add_executable(elffiletest elffiletest.cpp)
target_link_libraries(elffiletest Qt6::Test libelfdissector)
add_test(NAME elffiletest COMMAND elffiletest)

add_executable(elffilesettest elffilesettest.cpp)
target_link_libraries(elffilesettest Qt6::Test libelfdissector)
add_test(NAME elffilesettest COMMAND elffilesettest)

add_executable(elfsymboltabletest elfsymboltabletest.cpp)
target_link_libraries(elfsymboltabletest Qt6::Test libelfdissector)
add_test(NAME elfsymboltabletest COMMAND elfsymboltabletest)

add_executable(elfnotesectiontest elfnotesectiontest.cpp)
target_link_libraries(elfnotesectiontest Qt6::Test libelfdissector)
add_test(NAME elfnotesectiontest COMMAND elfnotesectiontest)

add_executable(elfgnusymbolversioningtest elfgnusymbolversioningtest.cpp)
if (LINKER_TYPE STREQUAL "BFD" OR LINKER_TYPE STREQUAL "GOLD")
    target_compile_definitions(elfgnusymbolversioningtest PRIVATE HAVE_SINGLE_VERSION_LINKER=0)
else()
    target_compile_definitions(elfgnusymbolversioningtest PRIVATE HAVE_SINGLE_VERSION_LINKER=1)
endif()
target_link_libraries(elfgnusymbolversioningtest Qt6::Test libelfdissector)
add_test(NAME elfgnusymbolversioningtest COMMAND elfgnusymbolversioningtest)

add_executable(elfhashtest elfhashtest.cpp)
target_link_libraries(elfhashtest Qt6::Test libelfdissector)
add_test(NAME elfhashtest COMMAND elfhashtest)

if (HAVE_DWARF)
add_executable(dwarfexpressiontest dwarfexpressiontest.cpp)
target_link_libraries(dwarfexpressiontest Qt6::Test Dwarf::Dwarf libelfdissector)
add_test(NAME dwarfexpressiontest COMMAND dwarfexpressiontest)

add_executable(dwarfleb128test dwarfleb128test.cpp)
target_link_libraries(dwarfleb128test Qt6::Test libelfdissector)
add_test(NAME dwarfleb128test COMMAND dwarfleb128test)

add_executable(dwarfdietest dwarfdietest.cpp)
target_link_libraries(dwarfdietest Qt6::Test Dwarf::Dwarf libelfdissector)
add_test(NAME dwarfdietest COMMAND dwarfdietest)
endif()

add_executable(elfmodeltest elfmodeltest.cpp)
target_link_libraries(elfmodeltest Qt6::Test libelfdissectorui)
add_test(NAME elfmodeltest COMMAND elfmodeltest)

add_executable(dependencymodeltest dependencymodeltest.cpp)
target_link_libraries(dependencymodeltest Qt6::Test libelfdissectorui)
add_test(NAME dependencymodeltest COMMAND dependencymodeltest)

if (HAVE_DWARF)
add_executable(typemodeltest typemodeltest.cpp)
target_link_libraries(typemodeltest Qt6::Test libelfdissectorui)
add_test(NAME typemodeltest COMMAND typemodeltest)
endif()

=== tests/targets/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2015 Volker Krause <vkrause@kde.org>
# SPDX-License-Identifier: BSD-2-Clause

set(CMAKE_AUTOMOC OFF)
add_executable(single-executable single-executable.c)
add_executable(structures structures.cpp)

add_executable(virtual-methods virtual-methods.cpp)
if (CMAKE_COMPILER_IS_GNUCXX)
    # we explicitly want this error in the test binary, so silence the corresponding warning
    target_compile_options(virtual-methods PRIVATE "-Wno-non-virtual-dtor")
endif()

add_executable(virtual-inheritance virtual-inheritance.cpp)

add_executable(qtstructures qtstructures.cpp)
target_link_libraries(qtstructures Qt6::Core)

add_library(versioned-symbols SHARED versioned-symbols.c)
set_target_properties(versioned-symbols PROPERTIES LINK_FLAGS "-Wl,--version-script ${CMAKE_CURRENT_SOURCE_DIR}/versioned-symbols.version")

=== tests/tools/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2015 Volker Krause <vkrause@kde.org>
# SPDX-License-Identifier: BSD-2-Clause

add_executable(demangle-ast demangle-ast.cpp)
target_link_libraries(demangle-ast Qt6::Core Binutils::Iberty)

=== src/lib/checks/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2019 Volker Krause <vkrause@kde.org>
# SPDX-License-Identifier: BSD-2-Clause

set(CMAKE_AUTOMOC OFF)
add_executable(ldbenchmark-runner ldbenchmark-runner.c)
target_link_libraries(ldbenchmark-runner dl rt)
install(TARGETS ldbenchmark-runner ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})

=== debian/changelog ===
elf-dissector (0.0+p24.04+vunstable+git20260105.1310-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Mon, 05 Jan 2026 13:10:46 +0000

## elf-dissector 0.0+p24.04+vunstable+git20260123.0345

=== debian/changelog ===
elf-dissector (0.0+p24.04+vunstable+git20260123.0345-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Fri, 23 Jan 2026 03:45:39 +0000

=== debian/control ===
Source: elf-dissector
Section: devel
Priority: optional
Build-Depends: binutils-dev,
               cmake,
               debhelper-compat (= 13),
               kf6-extra-cmake-modules (>= 5.27.0),
               kf6-kitemmodels-dev,
               libcapstone-dev,
               libdw-dev,
               libdwarf-dev,
               libelf-dev,
               libiberty-dev,
               qt6-base-dev,
               qt6-tools-dev
Standards-Version: 4.7.0
Vcs-Git: https://invent.kde.org/neon/neon-packaging/elf-dissector.git
Vcs-Browser: https://invent.kde.org/neon/neon-packaging/elf-dissector
Maintainer: Neon CI <neon@kde.org>

Package: elf-dissector
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: gnuplot
Description: Static analysis tool for ELF files
 ELF Dissector is useful if you need to do one or more of the following tasks:
  - Inspecting forward and backward dependencies, on library and symbol level
  - Identifying load-time performance bottlenecks such as expensive static
    constructors or excessive relocations
  - Size profiling of ELF files
 .
 Main features:
  - ELF structure browser
  - Tree map visualization of the size of the various parts of an ELF file
  - Relocation heatmap
  - Built-in disassembler for x86 and AArch64
  - Browser for data type memory layouts extracted from DWARF debug information
  - Forward and backward dependency viewer

=== debian/rules ===

#!/usr/bin/make -f
# SPDX-License-Identifier: LGPL-2.0-or-later
# # SPDX-FileCopyrightText: 2023 Jonathan Riddell <jr@jriddell.org>
%:
	dh $@ --with kf6 --buildsystem kf6

override_dh_auto_test:
	# Disable dh_auto_test at build time
	:
